# -*- mode: python; python-indent: 2 -*-
#
# xbrightness-rgbgamma - X11 brightness / gamma adjustment tool
#
# Copyright (C) 2011 kakurasan
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# THANKS:
#  xbrightness by Asher Blum and Jean-Daniel Pauget


class Xpm:
  """
  XPM data
  """
  _data = []
  size = 8
  @property
  def data (self): return self._data

class SingleColorXpm (Xpm):
  """
  XPM data (single color)
  """
  def __init__ (self, red, green, blue):
    self._data = ['{0} {0} 1 1\n'.format (Xpm.size * 2),
                  ' \tc #{0}{1}{2}'.format (red, green, blue)]
    for i in range (Xpm.size * 2):
      self._data.append (' ' * (Xpm.size * 2))

class AlternateXpm (Xpm):
  """
  XPM data (alternate)
  """
  def __init__ (self, red1, green1, blue1, red2, green2, blue2):
    self._data = ['{0} {0} 2 1'.format (Xpm.size * 2),
                  ' \tc #{0}{1}{2}'.format (red1, green1, blue1),
                  '.\tc #{0}{1}{2}'.format (red2, green2, blue2)]
    for i in range (Xpm.size):
      self._data.append ('. ' * Xpm.size)
      self._data.append (' .' * Xpm.size)
